// Code generated by go-swagger; DO NOT EDIT.

package customer

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/decentral1se/go-kimai/models"
)

// NewPostAPICustomersIDRatesParams creates a new PostAPICustomersIDRatesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAPICustomersIDRatesParams() *PostAPICustomersIDRatesParams {
	return &PostAPICustomersIDRatesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAPICustomersIDRatesParamsWithTimeout creates a new PostAPICustomersIDRatesParams object
// with the ability to set a timeout on a request.
func NewPostAPICustomersIDRatesParamsWithTimeout(timeout time.Duration) *PostAPICustomersIDRatesParams {
	return &PostAPICustomersIDRatesParams{
		timeout: timeout,
	}
}

// NewPostAPICustomersIDRatesParamsWithContext creates a new PostAPICustomersIDRatesParams object
// with the ability to set a context for a request.
func NewPostAPICustomersIDRatesParamsWithContext(ctx context.Context) *PostAPICustomersIDRatesParams {
	return &PostAPICustomersIDRatesParams{
		Context: ctx,
	}
}

// NewPostAPICustomersIDRatesParamsWithHTTPClient creates a new PostAPICustomersIDRatesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAPICustomersIDRatesParamsWithHTTPClient(client *http.Client) *PostAPICustomersIDRatesParams {
	return &PostAPICustomersIDRatesParams{
		HTTPClient: client,
	}
}

/*
PostAPICustomersIDRatesParams contains all the parameters to send to the API endpoint

	for the post API customers ID rates operation.

	Typically these are written to a http.Request.
*/
type PostAPICustomersIDRatesParams struct {

	// Body.
	Body *models.CustomerRateForm

	/* ID.

	   The customer to add the rate for
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post API customers ID rates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPICustomersIDRatesParams) WithDefaults() *PostAPICustomersIDRatesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post API customers ID rates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPICustomersIDRatesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) WithTimeout(timeout time.Duration) *PostAPICustomersIDRatesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) WithContext(ctx context.Context) *PostAPICustomersIDRatesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) WithHTTPClient(client *http.Client) *PostAPICustomersIDRatesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) WithBody(body *models.CustomerRateForm) *PostAPICustomersIDRatesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) SetBody(body *models.CustomerRateForm) {
	o.Body = body
}

// WithID adds the id to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) WithID(id int64) *PostAPICustomersIDRatesParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the post API customers ID rates params
func (o *PostAPICustomersIDRatesParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PostAPICustomersIDRatesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
