// Code generated by go-swagger; DO NOT EDIT.

package customer

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/decentral1se/go-kimai/models"
)

// NewPostAPICustomersParams creates a new PostAPICustomersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAPICustomersParams() *PostAPICustomersParams {
	return &PostAPICustomersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAPICustomersParamsWithTimeout creates a new PostAPICustomersParams object
// with the ability to set a timeout on a request.
func NewPostAPICustomersParamsWithTimeout(timeout time.Duration) *PostAPICustomersParams {
	return &PostAPICustomersParams{
		timeout: timeout,
	}
}

// NewPostAPICustomersParamsWithContext creates a new PostAPICustomersParams object
// with the ability to set a context for a request.
func NewPostAPICustomersParamsWithContext(ctx context.Context) *PostAPICustomersParams {
	return &PostAPICustomersParams{
		Context: ctx,
	}
}

// NewPostAPICustomersParamsWithHTTPClient creates a new PostAPICustomersParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAPICustomersParamsWithHTTPClient(client *http.Client) *PostAPICustomersParams {
	return &PostAPICustomersParams{
		HTTPClient: client,
	}
}

/*
PostAPICustomersParams contains all the parameters to send to the API endpoint

	for the post API customers operation.

	Typically these are written to a http.Request.
*/
type PostAPICustomersParams struct {

	// Body.
	Body *models.CustomerEditForm

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post API customers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPICustomersParams) WithDefaults() *PostAPICustomersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post API customers params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPICustomersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post API customers params
func (o *PostAPICustomersParams) WithTimeout(timeout time.Duration) *PostAPICustomersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post API customers params
func (o *PostAPICustomersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post API customers params
func (o *PostAPICustomersParams) WithContext(ctx context.Context) *PostAPICustomersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post API customers params
func (o *PostAPICustomersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post API customers params
func (o *PostAPICustomersParams) WithHTTPClient(client *http.Client) *PostAPICustomersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post API customers params
func (o *PostAPICustomersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post API customers params
func (o *PostAPICustomersParams) WithBody(body *models.CustomerEditForm) *PostAPICustomersParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post API customers params
func (o *PostAPICustomersParams) SetBody(body *models.CustomerEditForm) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *PostAPICustomersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
