// Code generated by go-swagger; DO NOT EDIT.

package expense

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/decentral1se/go-kimai/models"
)

// NewPatchAPIExpensesIDParams creates a new PatchAPIExpensesIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchAPIExpensesIDParams() *PatchAPIExpensesIDParams {
	return &PatchAPIExpensesIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchAPIExpensesIDParamsWithTimeout creates a new PatchAPIExpensesIDParams object
// with the ability to set a timeout on a request.
func NewPatchAPIExpensesIDParamsWithTimeout(timeout time.Duration) *PatchAPIExpensesIDParams {
	return &PatchAPIExpensesIDParams{
		timeout: timeout,
	}
}

// NewPatchAPIExpensesIDParamsWithContext creates a new PatchAPIExpensesIDParams object
// with the ability to set a context for a request.
func NewPatchAPIExpensesIDParamsWithContext(ctx context.Context) *PatchAPIExpensesIDParams {
	return &PatchAPIExpensesIDParams{
		Context: ctx,
	}
}

// NewPatchAPIExpensesIDParamsWithHTTPClient creates a new PatchAPIExpensesIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchAPIExpensesIDParamsWithHTTPClient(client *http.Client) *PatchAPIExpensesIDParams {
	return &PatchAPIExpensesIDParams{
		HTTPClient: client,
	}
}

/*
PatchAPIExpensesIDParams contains all the parameters to send to the API endpoint

	for the patch API expenses ID operation.

	Typically these are written to a http.Request.
*/
type PatchAPIExpensesIDParams struct {

	// Body.
	Body *models.ExpenseEditForm

	/* ID.

	   Expense ID to update
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch API expenses ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAPIExpensesIDParams) WithDefaults() *PatchAPIExpensesIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch API expenses ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAPIExpensesIDParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) WithTimeout(timeout time.Duration) *PatchAPIExpensesIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) WithContext(ctx context.Context) *PatchAPIExpensesIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) WithHTTPClient(client *http.Client) *PatchAPIExpensesIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) WithBody(body *models.ExpenseEditForm) *PatchAPIExpensesIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) SetBody(body *models.ExpenseEditForm) {
	o.Body = body
}

// WithID adds the id to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) WithID(id int64) *PatchAPIExpensesIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch API expenses ID params
func (o *PatchAPIExpensesIDParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchAPIExpensesIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
