// Code generated by go-swagger; DO NOT EDIT.

package project

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/decentral1se/go-kimai/models"
)

// NewPostAPIProjectsIDRatesParams creates a new PostAPIProjectsIDRatesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAPIProjectsIDRatesParams() *PostAPIProjectsIDRatesParams {
	return &PostAPIProjectsIDRatesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAPIProjectsIDRatesParamsWithTimeout creates a new PostAPIProjectsIDRatesParams object
// with the ability to set a timeout on a request.
func NewPostAPIProjectsIDRatesParamsWithTimeout(timeout time.Duration) *PostAPIProjectsIDRatesParams {
	return &PostAPIProjectsIDRatesParams{
		timeout: timeout,
	}
}

// NewPostAPIProjectsIDRatesParamsWithContext creates a new PostAPIProjectsIDRatesParams object
// with the ability to set a context for a request.
func NewPostAPIProjectsIDRatesParamsWithContext(ctx context.Context) *PostAPIProjectsIDRatesParams {
	return &PostAPIProjectsIDRatesParams{
		Context: ctx,
	}
}

// NewPostAPIProjectsIDRatesParamsWithHTTPClient creates a new PostAPIProjectsIDRatesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAPIProjectsIDRatesParamsWithHTTPClient(client *http.Client) *PostAPIProjectsIDRatesParams {
	return &PostAPIProjectsIDRatesParams{
		HTTPClient: client,
	}
}

/*
PostAPIProjectsIDRatesParams contains all the parameters to send to the API endpoint

	for the post API projects ID rates operation.

	Typically these are written to a http.Request.
*/
type PostAPIProjectsIDRatesParams struct {

	// Body.
	Body *models.ProjectRateForm

	/* ID.

	   The project to add the rate for
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post API projects ID rates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPIProjectsIDRatesParams) WithDefaults() *PostAPIProjectsIDRatesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post API projects ID rates params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPIProjectsIDRatesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) WithTimeout(timeout time.Duration) *PostAPIProjectsIDRatesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) WithContext(ctx context.Context) *PostAPIProjectsIDRatesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) WithHTTPClient(client *http.Client) *PostAPIProjectsIDRatesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) WithBody(body *models.ProjectRateForm) *PostAPIProjectsIDRatesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) SetBody(body *models.ProjectRateForm) {
	o.Body = body
}

// WithID adds the id to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) WithID(id int64) *PostAPIProjectsIDRatesParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the post API projects ID rates params
func (o *PostAPIProjectsIDRatesParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PostAPIProjectsIDRatesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
