// Code generated by go-swagger; DO NOT EDIT.

package tag

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/decentral1se/go-kimai/models"
)

// NewPostAPITagsParams creates a new PostAPITagsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAPITagsParams() *PostAPITagsParams {
	return &PostAPITagsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAPITagsParamsWithTimeout creates a new PostAPITagsParams object
// with the ability to set a timeout on a request.
func NewPostAPITagsParamsWithTimeout(timeout time.Duration) *PostAPITagsParams {
	return &PostAPITagsParams{
		timeout: timeout,
	}
}

// NewPostAPITagsParamsWithContext creates a new PostAPITagsParams object
// with the ability to set a context for a request.
func NewPostAPITagsParamsWithContext(ctx context.Context) *PostAPITagsParams {
	return &PostAPITagsParams{
		Context: ctx,
	}
}

// NewPostAPITagsParamsWithHTTPClient creates a new PostAPITagsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAPITagsParamsWithHTTPClient(client *http.Client) *PostAPITagsParams {
	return &PostAPITagsParams{
		HTTPClient: client,
	}
}

/*
PostAPITagsParams contains all the parameters to send to the API endpoint

	for the post API tags operation.

	Typically these are written to a http.Request.
*/
type PostAPITagsParams struct {

	// Body.
	Body *models.TagEditForm

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post API tags params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPITagsParams) WithDefaults() *PostAPITagsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post API tags params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPITagsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post API tags params
func (o *PostAPITagsParams) WithTimeout(timeout time.Duration) *PostAPITagsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post API tags params
func (o *PostAPITagsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post API tags params
func (o *PostAPITagsParams) WithContext(ctx context.Context) *PostAPITagsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post API tags params
func (o *PostAPITagsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post API tags params
func (o *PostAPITagsParams) WithHTTPClient(client *http.Client) *PostAPITagsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post API tags params
func (o *PostAPITagsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post API tags params
func (o *PostAPITagsParams) WithBody(body *models.TagEditForm) *PostAPITagsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post API tags params
func (o *PostAPITagsParams) SetBody(body *models.TagEditForm) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *PostAPITagsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
