// Code generated by go-swagger; DO NOT EDIT.

package task

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/decentral1se/go-kimai/models"
)

// NewPatchAPITasksIDLogParams creates a new PatchAPITasksIDLogParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchAPITasksIDLogParams() *PatchAPITasksIDLogParams {
	return &PatchAPITasksIDLogParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchAPITasksIDLogParamsWithTimeout creates a new PatchAPITasksIDLogParams object
// with the ability to set a timeout on a request.
func NewPatchAPITasksIDLogParamsWithTimeout(timeout time.Duration) *PatchAPITasksIDLogParams {
	return &PatchAPITasksIDLogParams{
		timeout: timeout,
	}
}

// NewPatchAPITasksIDLogParamsWithContext creates a new PatchAPITasksIDLogParams object
// with the ability to set a context for a request.
func NewPatchAPITasksIDLogParamsWithContext(ctx context.Context) *PatchAPITasksIDLogParams {
	return &PatchAPITasksIDLogParams{
		Context: ctx,
	}
}

// NewPatchAPITasksIDLogParamsWithHTTPClient creates a new PatchAPITasksIDLogParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchAPITasksIDLogParamsWithHTTPClient(client *http.Client) *PatchAPITasksIDLogParams {
	return &PatchAPITasksIDLogParams{
		HTTPClient: client,
	}
}

/*
PatchAPITasksIDLogParams contains all the parameters to send to the API endpoint

	for the patch API tasks ID log operation.

	Typically these are written to a http.Request.
*/
type PatchAPITasksIDLogParams struct {

	// Body.
	Body *models.TaskLogWorkForm

	/* ID.

	   Task ID to log times for
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch API tasks ID log params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAPITasksIDLogParams) WithDefaults() *PatchAPITasksIDLogParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch API tasks ID log params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAPITasksIDLogParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) WithTimeout(timeout time.Duration) *PatchAPITasksIDLogParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) WithContext(ctx context.Context) *PatchAPITasksIDLogParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) WithHTTPClient(client *http.Client) *PatchAPITasksIDLogParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) WithBody(body *models.TaskLogWorkForm) *PatchAPITasksIDLogParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) SetBody(body *models.TaskLogWorkForm) {
	o.Body = body
}

// WithID adds the id to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) WithID(id int64) *PatchAPITasksIDLogParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch API tasks ID log params
func (o *PatchAPITasksIDLogParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchAPITasksIDLogParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
