// Code generated by go-swagger; DO NOT EDIT.

package task

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/decentral1se/go-kimai/models"
)

// NewPatchAPITasksIDParams creates a new PatchAPITasksIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchAPITasksIDParams() *PatchAPITasksIDParams {
	return &PatchAPITasksIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchAPITasksIDParamsWithTimeout creates a new PatchAPITasksIDParams object
// with the ability to set a timeout on a request.
func NewPatchAPITasksIDParamsWithTimeout(timeout time.Duration) *PatchAPITasksIDParams {
	return &PatchAPITasksIDParams{
		timeout: timeout,
	}
}

// NewPatchAPITasksIDParamsWithContext creates a new PatchAPITasksIDParams object
// with the ability to set a context for a request.
func NewPatchAPITasksIDParamsWithContext(ctx context.Context) *PatchAPITasksIDParams {
	return &PatchAPITasksIDParams{
		Context: ctx,
	}
}

// NewPatchAPITasksIDParamsWithHTTPClient creates a new PatchAPITasksIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchAPITasksIDParamsWithHTTPClient(client *http.Client) *PatchAPITasksIDParams {
	return &PatchAPITasksIDParams{
		HTTPClient: client,
	}
}

/*
PatchAPITasksIDParams contains all the parameters to send to the API endpoint

	for the patch API tasks ID operation.

	Typically these are written to a http.Request.
*/
type PatchAPITasksIDParams struct {

	// Body.
	Body *models.TaskEditForm

	/* ID.

	   Task ID to update
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch API tasks ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAPITasksIDParams) WithDefaults() *PatchAPITasksIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch API tasks ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAPITasksIDParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the patch API tasks ID params
func (o *PatchAPITasksIDParams) WithTimeout(timeout time.Duration) *PatchAPITasksIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch API tasks ID params
func (o *PatchAPITasksIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch API tasks ID params
func (o *PatchAPITasksIDParams) WithContext(ctx context.Context) *PatchAPITasksIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch API tasks ID params
func (o *PatchAPITasksIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch API tasks ID params
func (o *PatchAPITasksIDParams) WithHTTPClient(client *http.Client) *PatchAPITasksIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch API tasks ID params
func (o *PatchAPITasksIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the patch API tasks ID params
func (o *PatchAPITasksIDParams) WithBody(body *models.TaskEditForm) *PatchAPITasksIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the patch API tasks ID params
func (o *PatchAPITasksIDParams) SetBody(body *models.TaskEditForm) {
	o.Body = body
}

// WithID adds the id to the patch API tasks ID params
func (o *PatchAPITasksIDParams) WithID(id int64) *PatchAPITasksIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch API tasks ID params
func (o *PatchAPITasksIDParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchAPITasksIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
