// Code generated by go-swagger; DO NOT EDIT.

package team

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/decentral1se/go-kimai/models"
)

// NewPostAPITeamsParams creates a new PostAPITeamsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostAPITeamsParams() *PostAPITeamsParams {
	return &PostAPITeamsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostAPITeamsParamsWithTimeout creates a new PostAPITeamsParams object
// with the ability to set a timeout on a request.
func NewPostAPITeamsParamsWithTimeout(timeout time.Duration) *PostAPITeamsParams {
	return &PostAPITeamsParams{
		timeout: timeout,
	}
}

// NewPostAPITeamsParamsWithContext creates a new PostAPITeamsParams object
// with the ability to set a context for a request.
func NewPostAPITeamsParamsWithContext(ctx context.Context) *PostAPITeamsParams {
	return &PostAPITeamsParams{
		Context: ctx,
	}
}

// NewPostAPITeamsParamsWithHTTPClient creates a new PostAPITeamsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostAPITeamsParamsWithHTTPClient(client *http.Client) *PostAPITeamsParams {
	return &PostAPITeamsParams{
		HTTPClient: client,
	}
}

/*
PostAPITeamsParams contains all the parameters to send to the API endpoint

	for the post API teams operation.

	Typically these are written to a http.Request.
*/
type PostAPITeamsParams struct {

	// Body.
	Body *models.TeamEditForm

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post API teams params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPITeamsParams) WithDefaults() *PostAPITeamsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post API teams params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostAPITeamsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post API teams params
func (o *PostAPITeamsParams) WithTimeout(timeout time.Duration) *PostAPITeamsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post API teams params
func (o *PostAPITeamsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post API teams params
func (o *PostAPITeamsParams) WithContext(ctx context.Context) *PostAPITeamsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post API teams params
func (o *PostAPITeamsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post API teams params
func (o *PostAPITeamsParams) WithHTTPClient(client *http.Client) *PostAPITeamsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post API teams params
func (o *PostAPITeamsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post API teams params
func (o *PostAPITeamsParams) WithBody(body *models.TeamEditForm) *PostAPITeamsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post API teams params
func (o *PostAPITeamsParams) SetBody(body *models.TeamEditForm) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *PostAPITeamsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
